## libreoffice 26.2.1~rc1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(afdko)

# set(CMAKE_VERBOSE_MAKEFILE ON)

# This matches the MSVC_RUNTIME_LIBRARY property in
# c/makeotf/source/CMakeLists.txt, which can theoretically be used to
# statically link the runtime on Windows. However, the neededruntime DLL
# seems to be present in Windows and setting this caused problems in testing.
# (Setting ANTLR4_WITH_STATIC_CRT below to ON may or may not fix the problem.)
# cmake_policy(SET CMP0091 NEW) # Style of MSVC runtime selection

# RelWithDebInfo builds an optimized binary but includes debugging symbols
# Other common possibilities are "Debug" and "Release"
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type configuration" FORCE)
endif()
message(STATUS "Build type is ${CMAKE_BUILD_TYPE}")

set(CMAKE_CXX_STANDARD 11)

# scikit-build
if(SKBUILD)
    find_package(PythonExtensions REQUIRED)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Antlr 4 configuration

# This is an alternate way of supplying the Antlr 4 sources that will override
# the git clone of the tag listed below. This is especially useful if you
# encounter compiler problems and need to make small edits to compensate. Start
# with the Antlr project's sources, e.g.
# https://www.antlr.org/download/antlr4-cpp-runtime-4.9.3-source.zip
# set(ANTLR4_ZIP_REPOSITORY "/path_to_antlr4_archive/a4.zip")

add_definitions(-DANTLR4CPP_STATIC)
set(ANTLR4_WITH_STATIC_CRT OFF)
# set(ANTLR4_TAG tags/4.13.2)
# This is a more recent commit than 4.13.2 that addresses a missing
# include directive needed in more recent Visual Studio releases
set(ANTLR4_TAG df4d68c09cdef73e023b8838a8bc7ca4dff1d1de)
include(ExternalAntlr4Cpp)


if (DEFINED ENV{FORCE_BUILD_LIBXML2})
    set(BUILD_STATIC_LIBXML2 TRUE)
else()
    FIND_PACKAGE(LibXml2)
    if (${LibXml2_FOUND})
        set(BUILD_STATIC_LIBXML2 FALSE)
    elseif (DEFINED ENV{FORCE_SYSTEM_LIBXML2})
        message(FATAL_ERROR "FORCE_SYSTEM_LIBXML2 set but LibXML2 not found")
    else()
        set(BUILD_STATIC_LIBXML2 TRUE)
    endif()
endif()

if (${BUILD_STATIC_LIBXML2})
    message(STATUS "LibXML2 not found or overridden -- will download and statically link")
    set(LIBXML2_TAG tags/v2.9.13)
    include(ExternalLibXML2)
    include_directories(${LIBXML2_STATIC_INCLUDE_DIR})
    set(NEED_LIBXML2_DEPEND TRUE)
    if (WIN32)
        set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_WIN_LIBRARIES})
    else()
        set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_NONWIN_LIBRARIES})
    endif()
else()
    include_directories(${LIBXML2_INCLUDE_DIR})
    set(NEED_LIBXML2_DEPEND FALSE)
    set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_LIBRARY})
endif()

# sanitizer support
# work around https://github.com/pypa/setuptools/issues/1928 with environment
# variable
if(DEFINED ENV{ADD_SANITIZER})
    set(ADD_SANITIZER "$ENV{ADD_SANITIZER}" CACHE STRING "Sanitizer type (\"none\" for no sanitizer")
else()
    set(ADD_SANITIZER "none" CACHE STRING "Sanitizer type (\"none\" for no sanitizer")
endif()
include(AddSanitizer)
add_sanitizer("${ADD_SANITIZER}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
# Ported from old build files, XXX not sure if all of these are needed
if(WIN32)
    add_compile_definitions(CTL_CDECL=__cdecl CDECL=__cdecl
        OS=os_windowsNT ISP=isp_i80486 _CRT_SECURE_NO_DEPRECATE
        $<$<CONFIG:Release>:NDEBUG>)
endif()

include(CheckLibraryExists)
CHECK_LIBRARY_EXISTS(m floor "" HAVE_M_LIB)

include(CTest)
include(AddAFDKOTests)

add_subdirectory(c/shared/source)
add_subdirectory(c/detype1/source)
add_subdirectory(c/mergefonts/source)
add_subdirectory(c/rotatefont/source)
add_subdirectory(c/sfntdiff/source)
add_subdirectory(c/sfntedit/source)
add_subdirectory(c/spot/source)
add_subdirectory(c/tx/source)
add_subdirectory(c/type1/source)
add_subdirectory(c/makeotf)

=== tests-ffi/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15.3)
project(yrs-ffi-tests)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_OSX_ARCHITECTURES "x86_64")

message(STATUS "current project dir: " ${PROJECT_SOURCE_DIR})
add_executable(yrs-ffi-tests main.cpp)

if (WIN32)
    target_compile_options(yrs-ffi-tests PRIVATE "$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
    add_custom_target(yrs-deps
            # DEBUG
            COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/../target/debug/yrs.lib" "${PROJECT_SOURCE_DIR}/lib"
    )
else ()
    add_custom_target(yrs-deps
            # DEBUG
            COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/../target/debug/libyrs.a" "${PROJECT_SOURCE_DIR}/lib"
    )
endif ()

include_directories(${PROJECT_SOURCE_DIR}/lib)
include_directories(${PROJECT_SOURCE_DIR}/include)

link_directories(${PROJECT_SOURCE_DIR}/lib)
add_dependencies(yrs-ffi-tests yrs-deps)
find_library(
        YRS_LIB
        NAMES yrs libyrs # what to look for
        HINTS "${PROJECT_SOURCE_DIR}/../target/debug/" # where to look
        NO_DEFAULT_PATH # do not search system default paths
)

link_libraries(ws2_32 wsock32 userenv)

if (WIN32)
    target_link_libraries(yrs-ffi-tests LINK_PUBLIC ${YRS_LIB} wsock32 ws2_32 userenv bcrypt)
else ()
    target_link_libraries(yrs-ffi-tests LINK_PUBLIC ${YRS_LIB} pthread dl)
endif ()

=== contrib/slapd-modules/allowed/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2026 The OpenLDAP Foundation.
# Copyright 2004 Howard Chu, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

PLAT = UNIX
NT_LIB = -L$(LDAP_BUILD)/servers/slapd -lslapd
NT_LDFLAGS = -no-undefined -avoid-version
UNIX_LDFLAGS = -version-info $(LTVER)

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2
DEFS = -DSLAPD_OVER_ALLOWED=SLAPD_MOD_DYNAMIC
INCS = $(LDAP_INC)
LIBS = $($(PLAT)_LIB) $(LDAP_LIB)
LD_FLAGS = $(LDFLAGS) $($(PLAT)_LDFLAGS) -rpath $(moduledir) -module

PROGRAMS = allowed.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

allowed.la: allowed.lo
	$(LIBTOOL) --mode=link $(CC) $(LD_FLAGS) -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== debian/changelog ===
libreoffice (4:26.2.1~rc1-0ubuntu1) resolute; urgency=medium

  * New upstream release candidate
  * Use internal afdko
    - the required version > 4.0.x is not available yet

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Sat, 07 Feb 2026 00:25:31 +0100

libreoffice (4:26.2.1~rc1-1) experimental; urgency=medium

  * New upstream release candidate

 -- Rene Engelhard <rene@debian.org>  Fri, 06 Feb 2026 01:28:05 +0100

=== debian/control ===
#
# NOTE: This file is autogenerated. DO NOT manually edit it! 
# Edit debian/control*in and rules (whatever applicable), run debian/rules control
# and move control.new to control if the difference is sane.
#
Source: libreoffice
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian LibreOffice Maintainers <debian-openoffice@lists.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>, Chris Halls <halls@debian.org>
Build-Depends: ant <!nojava>,
               ant-optional <!nojava>,
               autoconf,
               automake,
               bc,
               bison,
               bzip2,
               cargo,
               clang [i386],
               debhelper-compat (= 12),
               default-jdk (>= 2:1.9) [!hppa !hurd-amd64 !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !powerpcspe !s390 !sparc] <!nojava>,
               dh-python <!nopython>,
               dpkg-dev (>= 1.22.5) [armhf],
               flex,
               g++ (>= 4:12) [!i386],
               gcc (>= 4:12) [!i386],
               gperf,
               java-common (>= 0.75) <!nojava>,
               javahelper <!nojava>,
               junit4 [amd64 arm64] <!nocheck !nojava>,
               libabw-dev (<< 0.2~),
               libabw-dev (>= 0.1),
               libarchive-zip-perl <!nojava>,
               libargon2-dev,
               libbluetooth-dev [linux-any],
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-locale-dev,
               libcairo2-dev,
               libcdr-dev (<< 0.2~),
               libcdr-dev (>= 0.1),
               libclucene-dev,
               libcpdb-frontend-dev,
               libcrypt-dev,
               libcups2-dev,
               libcurl4-openssl-dev,
               libdconf-dev (>= 0.40),
               libe-book-dev (<< 0.2~),
               libe-book-dev (>= 0.1),
               libeot-dev,
               libepoxy-dev,
               libepubgen-dev (<< 0.2~),
               libepubgen-dev (>= 0.1.0),
               libetonyek-dev,
               libetonyek-dev (<< 0.2~),
               libexpat1-dev,
               libexttextcat-dev,
               libfast-float-dev,
               libfontconfig-dev,
               libfreehand-dev (<< 0.2~),
               libfreehand-dev (>= 0.1),
               libfreetype-dev,
               libgl-dev,
               libglib2.0-dev,
               libglm-dev,
               libgraphite2-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libharfbuzz-dev (>= 5.1.0),
               libhsqldb1.8.0-java <!nojava>,
               libhunspell-dev,
               libhyphen-dev,
               libice-dev,
               libicu-dev,
               libjpeg-dev,
               libkrb5-dev,
               liblangtag-dev,
               liblcms2-dev,
               liblockfile-bin,
               libmd4c-dev,
               libmdds-dev (<< 3.3~),
               libmdds-dev (>= 3.0),
               libmspub-dev (<< 0.2~),
               libmspub-dev (>= 0.1),
               libmwaw-dev (<< 0.4~),
               libmwaw-dev (>= 0.3.21),
               libmythes-dev,
               libnspr4-dev,
               libnss3-dev,
               libodfgen-dev (<< 0.2~),
               libodfgen-dev (>= 0.1),
               liborcus-dev (<< 0.22~),
               liborcus-dev (>= 0.21),
               libpagemaker-dev,
               libpagemaker-dev (<< 0.1~),
               libpng-dev,
               libpoppler-cpp-dev,
               libpoppler-dev,
               libpoppler-private-dev,
               librdf0-dev,
               librevenge-dev,
               librevenge-dev (<< 0.1~),
               libsane-dev,
               libsm-dev,
               libsuitesparse-dev,
               libtiff-dev,
               libvisio-dev (<< 0.2~),
               libvisio-dev (>= 0.1),
               libwebp-dev,
               libwpd-dev (<< 0.11~),
               libwpd-dev (>= 0.10),
               libwpg-dev (<< 0.4~),
               libwpg-dev (>= 0.3),
               libwps-dev (<< 0.5~),
               libwps-dev (>= 0.4),
               libx11-dev,
               libx11-xcb-dev,
               libxaw7-dev,
               libxext-dev,
               libxinerama-dev,
               libxkbfile-dev,
               libxml2-dev,
               libxml2-utils,
               libxmlsec1-dev (>= 1.2.35),
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               libxt-dev,
               libxtst-dev,
               libzstd-dev,
               maven-repo-helper <!nojava>,
               mold [riscv64],
               pkgconf,
               po-debconf,
               python3,
               python3-dev <!nopython>,
               python3-setuptools <!nopython>,
               rustc,
               unixodbc-dev,
               unzip,
               x11proto-render-dev,
               xsltproc,
               zip,
               zlib1g-dev
Build-Depends-Arch: at-spi2-core [!ppc64el !riscv64 !s390x] <!nocheck>,
                    clang [!s390x],
                    culmus [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    dbus-x11 [!ppc64el !riscv64 !s390x] <!nocheck>,
                    default-libmysqlclient-dev,
                    dh-cargo,
                    firebird-dev (<< 5.0~),
                    firebird-dev (>= 4.0),
                    firebird4.0-server-core <!nocheck>,
                    fontconfig [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-crosextra-caladea [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-crosextra-carlito (>= 20230309) [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-dejavu [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-hosny-amiri (>= 1.000) [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-liberation (>= 1:2) [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-linuxlibertine [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-noto-core [amd64 arm64 armhf i386 ppc64el s390x] <!nocheck>,
                    fonts-opensymbol <!pkg.libreoffice.opensymbolbuild>,
                    gdb [!ppc64el !riscv64 !s390x] <!nocheck>,
                    ghostscript [!ppc64el !riscv64 !s390x] <!nocheck>,
                    gir1.2-gdk-3.0-dev <!nogir>,
                    gir1.2-gdkpixbuf-2.0-dev <!nogir>,
                    gir1.2-gio-2.0-dev <!nogir>,
                    gir1.2-gobject-2.0-dev <!nogir>,
                    gir1.2-gtk-3.0-dev <!nogir>,
                    gobject-introspection (>= 1.80) <!nogir>,
                    gpg [!ppc64el !riscv64 !s390x] <!nocheck>,
                    gpg-agent [!ppc64el !riscv64 !s390x] <!nocheck>,
                    gpgconf [!ppc64el !riscv64 !s390x] <!nocheck>,
                    hunspell-en-us [!ppc64el !riscv64 !s390x] <!nocheck>,
                    hyphen-de [!ppc64el !riscv64 !s390x] <!nocheck>,
                    hyphen-en-us [!ppc64el !riscv64 !s390x] <!nocheck>,
                    hyphen-hu [!ppc64el !riscv64 !s390x] <!nocheck>,
                    imagemagick [!ppc64el !riscv64 !s390x] <!nocheck>,
                    libabsl-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
                    libatk1.0-dev,
                    libatspi2.0-dev [!ppc64el !riscv64 !s390x] <!nocheck>,
                    libavahi-client-dev,
                    libcairo2-dev,
                    libcppunit-dev,
                    libdbus-1-dev,
                    libebook1.2-dev,
                    libglib2.0-dev,
                    libgpg-error-dev,
                    libgpgme-dev,
                    libgpgmepp-dev,
                    libgtk-3-dev,
                    libgtk-4-dev (>= 4.10),
                    libkf6config-dev,
                    libkf6coreaddons-dev,
                    libkf6i18n-dev,
                    libkf6kio-dev,
                    libkf6windowsystem-dev,
                    libldap-dev,
                    libopenjp2-7-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
                    libpq-dev,
                    libxcb1-dev,
                    libxml2-dev (>= 2.14.3+dfsg-0exp3) <!nocheck>,
                    libxmlsec1-dev (>= 1.2.39-5) [armhf] <!nocheck>,
                    locales <!nocheck> | locales-all <!nocheck>,
                    poppler-data [!ppc64el !riscv64 !s390x] <!nocheck>,
                    pstoedit [!ppc64el !riscv64 !s390x] <!nocheck>,
                    python3-lxml [!ppc64el !riscv64 !s390x] <!nocheck !nopython>,
                    python3-pip [!ppc64el !riscv64 !s390x] <!nocheck !nopython>,
                    python3-setuptools [!ppc64el !riscv64 !s390x] <!nocheck !nopython>,
                    python3-venv [!ppc64el !riscv64 !s390x] <!nocheck !nopython>,
                    qmake6 (>= 6.5.0),
                    qt6-base-dev (>= 6.5.0),
                    qt6-base-dev-tools (>= 6.5.0),
                    qt6-multimedia-dev (>= 6.5.0) [!m68k],
                    xauth [!ppc64el !riscv64 !s390x] <!nocheck>,
                    xvfb [!ppc64el !riscv64 !s390x] <!nocheck>
Build-Depends-Indep: apparmor <!nocheck>,
                     dh-apparmor,
                     doxygen <!nodoc>,
                     fontforge-nox | fontforge <!pkg.libreoffice.noopensymbolbuild>,
                     gettext,
                     graphviz <!nodoc>,
                     junit4 <!nojava>,
                     libbsh-java <!nojava>,
                     librhino-java <!nojava>,
                     rdfind,
                     symlinks
Build-Conflicts: amd-libopencl1,
                 clang [s390x],
                 gpg-from-sq [amd64 arm64 armhf] <!nocheck>,
                 nvidia-glx-dev,
                 nvidia-glx-legacy-dev,
                 nvidia-libopencl1
Standards-Version: 4.0.1
Rules-Requires-Root: no
Vcs-Git: https://git.launchpad.net/~libreoffice/ubuntu/+source/libreoffice -b ubuntu-resolute-26.2
Vcs-Browser: https://git.launchpad.net/~libreoffice/ubuntu/+source/libreoffice
Bugs: mailto:libreoffice@lists.launchpad.net
Homepage: http://www.libreoffice.org

Package: libreoffice
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Section: metapackages
Depends: libreoffice-base,
         libreoffice-calc,
         libreoffice-core (= ${binary:Version}),
         libreoffice-draw,
         libreoffice-impress,
         libreoffice-math,
         libreoffice-report-builder-bin,
         libreoffice-writer,
         ${misc:Depends},
         ${pyuno-depends}
Recommends: fonts-crosextra-caladea,
            fonts-crosextra-carlito,
            fonts-dejavu,
            fonts-linuxlibertine,
            fonts-noto-core,
            fonts-noto-extra,
            fonts-noto-mono,
            fonts-noto-ui-core,
            fonts-sil-gentium-basic,
            libreoffice-gnome | libreoffice-plasma,
            libreoffice-nlpsolver,
            libreoffice-report-builder,
            libreoffice-script-provider-bsh,
            libreoffice-script-provider-js,
            libreoffice-script-provider-python,
            libreoffice-sdbc-mysql,
            libreoffice-sdbc-postgresql,
            libreoffice-wiki-publisher,
            python3-pip,
            python3-setuptools,
            python3-venv,
            ${java-common-depends},
            ${liberation-fonts-recommends}
Suggests: cups-bsd,
          firefox | firefox-esr | thunderbird,
          ghostscript,
          gnupg,
          gpa,
          hunspell-dictionary,
          hyphen-hyphenation-patterns,
          imagemagick,
          libgl1,
          libreoffice-grammarcheck,
          libreoffice-help (= ${help-l10n-virtual-version}),

=== debian/rules ===
#!/usr/bin/make -f
################################################################################
# LibreOffice source package rules file
#
# Please see debian/README for detailed documentation about the build system, and
# how to build LibreOffice.
################################################################################
# Authors:
# Chris Halls <halls@debian.org>
# Rene Engelhard <rene@debian.org>
# Copyright 2002-2025 Software in the Public Interest, Inc.
# Portions Copyright 2010 Canonical Ltd. Author: Matthias Klose
# Portions Copyright 2011-2013 Canonical Ltd. Author: Bjoern Michaelsen
# Licensed under the GNU General Public License, version 2.  See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
################################################################################

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

include /usr/share/dpkg/pkg-info.mk
CURDIR ?= $(realpath $(dir $(firstword $(MAKEFILE_LIST)))/..)
BASE_VERSION:=$(shell echo $(DEB_VERSION) | cut -d: -f1):$(DEB_VERSION_UPSTREAM)
BINARY_VERSION=$(DEB_VERSION)
OOVER:=26.2
HELP_L10N_VIRTUAL_VERSION:=$(OOVER)
ifeq "$(shell echo $(OOVER) | cut -d. -f2)" "2"
# 24.2 + .6 -> 24.8 -> OK
NEXT_OOVER=$(shell echo "$(OOVER) + .6" | bc)
else
# 24.8 + .6 = 25.4 -> wrong (doesn't take into account that the year
# has 12 months)so subtract 2 (so effectively + .4) to get back to February (25.2),
# which is supposed to be the schedule.
NEXT_OOVER=$(shell echo "$(OOVER) + .4" | bc)
endif

ARCH_INDEP_PACKAGES := $(shell dh_listpackages -i)
ARCH_DEP_PACKAGES := $(shell dh_listpackages -a)
PACKAGES := $(ARCH_INDEP_PACKAGES) $(ARCH_DEP_PACKAGES)

ifneq (,$(shell pwd | grep autopkgtest))
AUTOPKGTEST_BUILD=y
$(warning Build for autopkgtest)
endif
AUTOPKGTEST_CPPUNIT_PACKAGES := $(shell dh_listpackages | grep -v help | grep -v l10n | grep -v dev-doc | grep -v "nogui$$")

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/vendor.mk
SHELL:=/bin/bash

SYSTEM_GCC_VERSION = $(shell gcc --version | sed -n '/^gcc/s/.*\(..\..\)\../\1/p' | cut -d" " -f1 | cut -d. -f1)
SYSTEM_CLANG_VERSION = $(shell clang -v 2>&1 | head -n1 | awk '{ print $$4 }' | cut -d. -f1)

PKGDIR:=debian/libreoffice
OODIRNAME=libreoffice
OODIR:=usr/lib/$(OODIRNAME)
OOSDKDIR:=$(OODIR)/sdk

# Figure out who's building this package.
ifneq "$(DEB_VENDOR)" "Debian"
OOO_VENDOR:=The Document Foundation, $(DEB_PARENT_VENDOR) and $(DEB_VENDOR)
else
OOO_VENDOR=The Document Foundation/$(DEB_VENDOR)
endif
export OOO_VENDOR

# debhelper
export DH_OPTIONS
export DH_ALWAYS_EXCLUDE=CVS:.svn:.bzr:.git
#export DH_VERBOSE=1
# quilt
export QUILT_PATCHES=debian/patches
export QUILT_OPTIONS="-p1 -F0"

SOURCE_TREE=.
STAMP_DIR=debian/stampdir
TARFILE_LOCATION=$(CURDIR)/tarballs
export TARFILE_LOCATION
USE_SOURCE_TARBALLS=n
USE_GIT_TARBALLS=n
ifeq "$(USE_GIT_TARBALLS)" "y"
GIT_BASEURL:=git://anongit.freedesktop.org/libreoffice
# bootstraping this from the source tree is breaking get-orig-source
#lo_sources_ver=$(shell grep AC_INIT $(SOURCE_TREE)/configure.ac | grep documentfoundation | cut -d, -f2 | sed -e 's,\[,,' -e 's,\],,')
lo_sources_ver=26.2.1.1
# NOT in proper libreoffice-3-6 branch
# use ./g checkout -b tag-libreoffice-3.6.2.1 libreoffice-3.6.2.1
GIT_TAG=libreoffice-$(lo_sources_ver)
GIT_BRANCH=libreoffice-26-2-1
endif
ifeq "$(USE_SOURCE_TARBALLS)" "y"
lo_sources_ver=$(shell cat $(CURDIR)/sources.ver | cut -d= -f2)
endif

ifeq "$(USE_GIT_TARBALLS)" "y"
YARU_GIT_TAG=2025-09-07
endif

YARU_ACCENTS = bark blue magenta olive prussiangreen purple red sage viridian wartybrown yellow mate
YARU_IMAGES = yaru yaru_svg $(foreach y, $(YARU_ACCENTS),yaru_$(y) yaru_$(y)_svg)

#########
# Default package configuration
#
# FIXME: Should riscv64 be here at all given it doesn't support NaN payload propagation which LO (at least Calc) needs?
# see https://bugs.documentfoundation.org/show_bug.cgi?id=152943 and https://lists.debian.org/debian-riscv/2024/01/msg00018.html
OOO_ARCHS = amd64 arm64 armhf ppc64el riscv64 s390x
PATCHSET=$(DEB_VENDOR)
BUILD_DEPS=\
    autoconf,\
    automake,\
    bc,\
    bison,\
    bzip2,\
    flex, \
    gperf,\
    libfreetype-dev,\
    libfontconfig-dev,\
    pkgconf,\
    po-debconf,\
    unzip,\
    xsltproc,\
    zip,\
    zlib1g-dev\

BUILD_DEPS_INDEP += rdfind, symlinks

# These are components which can be built from internal copies, or used from the
# distribution. See configure --help for valid values (--with-system-<value>).
SYSTEM_STUFF = dicts

ENABLE_GUI=y

ifeq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
ENABLE_PYTHON=y
ifeq "$(ENABLE_PYTHON)" "y"
  CONFIGURE_FLAGS += --enable-python=system
  ENABLE_SCRIPT_PROVIDER_PYTHON=y
  PACKAGE_LIBRELOGO=y
endif
# THIS IS ONLY FOR TESTING. When building against a specified pythonX.Y
# this will work inside OOo but *not* from outside OOo unless the user
# uses pythonX.Y directly (and the dh_pycentral-created dependencies allow
# also the non-working default python then) - see e.g. #587402. Also
# note we are NOT working with python < 2.6 anymore!
PYTHON_VERSION=current
ifeq "$(PYTHON_VERSION)" "current"
  PYTHON=python3
  export PYTHON
else
  # somehow configure insists on using python3 "for pyuno". The only way to
  # override this (afaics) is this...
  PYTHON=python$(PYTHON_VERSION)
  PYTHON_CFLAGS=$(shell pkg-config --cflags python-$(PYTHON_VERSION))
  PYTHON_LIBS=$(shell pkg-config --libs python-$(PYTHON_VERSION))
  export PYTHON PYTHON_VERSION PYTHON_CFLAGS PYTHON_LIBS
endif
endif
BUILD_ONLY_EN_US=n
ifeq ($(filter nojava,$(DEB_BUILD_PROFILES)),)
  include /usr/share/java/java_defaults.mk
  ifneq ($(DEB_HOST_ARCH),$(filter-out $(DEB_HOST_ARCH),$(java_unsupported_architectures)))
      ENABLE_JAVA=y
  endif
  ifeq "$(ENABLE_JAVA)" "y"
    JDK=default
    ifneq "$(JDK)" "default"
      JAVA_MAINVER=17
    endif
  endif
else
  ENABLE_JAVA=n
endif
#JAVAHELPER_MIN_VERSION=
SYSTEM_STUFF += hunspell
SYSTEM_STUFF += altlinuxhyph
SYSTEM_STUFF += boost
BOOST_VERSION=default
# libmdds-dev depends on libboost-dev, which will be removed
# when you install a non-default libboostX.Y-dev
ifeq "$(BOOST_VERSION)" "default"
SYSTEM_STUFF += mdds
endif
USE_EXTERNAL_CXXLIBS=y
SYSTEM_STUFF += mythes
SYSTEM_STUFF += icu
SYSTEM_STUFF += librevenge
SYSTEM_STUFF += libwpd libwpg libwps
SYSTEM_STUFF += libvisio
SYSTEM_STUFF += libcdr
SYSTEM_STUFF += libmspub
SYSTEM_STUFF += libmwaw
SYSTEM_STUFF += libodfgen
SYSTEM_STUFF += libepubgen
SYSTEM_STUFF += libetonyek
SYSTEM_STUFF += libfreehand
# this is libe-book, NOT evolutions libebook (which is
# dlopen()'ed anyway and whose headers we need from the
# system anyways if enabled
SYSTEM_STUFF += libebook
SYSTEM_STUFF += libabw
SYSTEM_STUFF += libpagemaker
SYSTEM_STUFF += libzmf
SYSTEM_STUFF += libstaroffice
SYSTEM_STUFF += libqxp
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH),loong64))
ENABLE_ZXING=y
endif
SYSTEM_STUFF += zxing
BUILD_CAIROCANVAS=y
SYSTEM_STUFF += cairo
ENABLE_GPGMEPP=y
ifeq "$(ENABLE_GUI)" "y"
BUILD_PLASMA=y
# let's assume we won't ship two plasmas parallel..
PLASMA_VERSION=6
PLASMA_KF_VERSION=$(PLASMA_VERSION)
PLASMA_ARCHITECTURE=all
ENABLE_QT5=n
#QT5_MINVER=
ENABLE_KF5=n
ENABLE_QT6=y
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH),m68k))
ENABLE_QT6_MULTIMEDIA=y
endif
ENABLE_KF6=y
endif
# go sure. if we want plasma, we want kfX, too and if we want that
# one we want qtX, too.
ifeq "$(BUILD_PLASMA)" "y"
   ifeq "$(PLASMA_VERSION)" "5"
     ENABLE_KF5=y
   endif
   ifeq "$(PLASMA_VERSION)" "6"
	ENABLE_KF6=y
  endif
endif
# KF5 depends on Qt5
ifeq "$(ENABLE_KF5)" "y"
  ENABLE_QT5=y
  KF5_QT5_DEPENDS := libreoffice-qt5 (= $${binary:Version})
endif
# KF6 depends on Qt6
ifeq "$(ENABLE_KF6)" "y"
  ENABLE_QT6=y
  KF6_QT6_DEPENDS := libreoffice-qt6 (= $${binary:Version})
endif
# https://www.debian.org/doc/debian-policy/ says this is not defined and must
# be ignored, but dh_strip mentions (and honours) it, so...
ifneq (noautodbgsym,$(findstring noautodbgsym,$(DEB_BUILD_OPTIONS)))

=== debian/tests/control ===
#
# NOTE: This file is autogenerated. DO NOT manually edit it! 
# Edit debian/tests/control*in and rules (whatever applicable), run debian/rules control
# and move control.new to control if the difference is sane.
#
Tests: testtools-bridgetest-without-java
Architecture: 
Depends: @builddeps@, ure
Restrictions: allow-stderr, rw-build-tree, superficial

Tests: testtools-bridgetest-with-java
Architecture: amd64 arm64
Depends: @builddeps@, ure-java, liblibreoffice-java, default-jdk
Restrictions: allow-stderr, rw-build-tree, superficial

Tests: pyuno-import, uno-import
Depends: python3, python3-uno
Restrictions: superficial

Tests: access2base-import
Depends: python3, python3-access2base
Restrictions: superficial

Tests: scriptforge-import
Depends: python3, python3-scriptforge
Restrictions: superficial

## Is there a need for this small test given we run the UI tests etc.?
#Tests: smoketest
#Architecture: amd64 arm64
#Depends: @builddeps@, libreoffice-smoketest-data, libreoffice-dev, libreoffice-core, libreoffice-writer, libreoffice-calc, libreoffice-impress, libreoffice-math, libreoffice-base, libreoffice-sdbc-hsqldb, libreoffice-sdbc-firebird
#Restrictions: allow-stderr, build-needed, rw-build-tree, superficial

# this is already done by smoketest upstream, but fails when doing it against
# the installed LO. works standalone, though, so it's patched out of the
# smoketest. Do it here separately.
Tests: test-extension
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Depends: libreoffice-core-nogui | libreoffice-core, libreoffice-common, libreoffice-java-common, libreoffice-smoketest-data, default-jdk
Restrictions: allow-stderr, superficial, skippable

Tests: test-extension-shared
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Depends: libreoffice-core-nogui | libreoffice-core, libreoffice-common, libreoffice-java-common, libreoffice-smoketest-data, default-jdk
Restrictions: allow-stderr, needs-root, superficial

# in the following some tests need RTL and CJK language packs installed to pass.
# he is the example for RTL, zh-tw for CJK (and zh-tw was choosen to also test xx-YY locales)

# Maybe all those tests should be merged into one (especially for the "small" ones like writerperfect or
# "tiny" ones like sfx2,svx,cui.
# But it already takes ~1.5 h (though including copy..) for all them to run on amd64 and the overall autopkgtest
# test timeout is 166 min (a bit over 2.5 hrs.). What are we doing on slow archs?
# And secondly. one might miss breakage if Java or another package is not installed but is
# required because everything needed would be in Depends: then for one test...
# Try to optimize a bit though by not sorting alphabetically but where the  new packages are a superset so
# we can reuse the testbed

Tests: uicheck-sfx2
Depends: @builddeps@, libreoffice-core, libreoffice-impress, python3-uno
Restrictions: allow-stderr

Tests: uicheck-svx
Depends: @builddeps@, libreoffice-core, libreoffice-impress, python3-uno
